<?php 
/*
Plugin Name: Restaurant Bookings
Plugin URI: http://wordpress.org/extend/plugins/restaurant-bookings/
Description: 
Version: 0.0.1
Author: listae
Author URI: http://listae.com/
*/

// Languages / Idiomas
load_theme_textdomain("default", "/" . dirname(plugin_basename(__FILE__)) . "/languages");

class RestaurantBooking {
	var $plugin_nice_name = "restaurant-bookings";
	var $version = "0.1";
	
	function get_url() {
		return plugins_url() . "/" . $this->plugin_nice_name . "/";
	}
	
	function init() {
		add_filter("mce_external_plugins", array($this, "mce_external_plugins"));
		add_filter("mce_buttons", array($this, "mce_buttons"));
		wp_register_style("rbktmce", $this->get_url() . "js/rbktmce/css/rbktmce.css", null, $version);
		wp_enqueue_style("rbktmce");
		
		// La css del plugin tmce (ruta relativa al theme)
		add_editor_style( "../../plugins/" . $this->plugin_nice_name . "/js/rbktmce/css/rbktmce.css" );
	}
	
	function mce_external_plugins($plugins) {
		$plugins["rbktmce"] = $this->get_url() . "js/rbktmce/rbktmce.js";
		return $plugins;
	}
	
	function mce_buttons($buttons) {
		// TODO: Poner el boton delante del boton de mostrar mas botones
		$buttons[] = "rbktmce_button";
		return $buttons;
	}
	
	/**
	 * Dibuja el formulario de reservas en cuestion...
	 * 
	 * @param array $args 
	 * 		"id", identificador de negocio. 
	 * 		"skin", disenyo.
	 */
	function rbkform($args) {
		$args = shortcode_atts(array("id" => "", "skin" => "light"), $args);
		
		$origen = get_permalink();
		
		return "<iframe class=\"rbkform\" width=\"100%\" height=\"750px\" ".
			"frameborder=\"0\" marginheight=\"0\" marginwiddth=\"0\" allowtransparency=\"true\" " .
			"src=\"" . $this->get_booking_url() . "?slug=" . urlencode($args["id"]) . 
			"&origin=" . urlencode($origen) . "&css=" . urlencode($args["skin"]) . "\"></iframe>";
	}
	
	private function get_booking_url() {
		$base_url = get_option("rb_url");
		$base_url = $base_url ? $base_url : "http://listae.com/r2console/";
		
		return $base_url . "bookings/publicBookingDetails.html";
	}
}

$rbk = new RestaurantBooking();
add_action("admin_menu", array ($rbk, "init"));

// Shortcodes
add_shortcode("rbkform", array ($rbk, "rbkform"));

